//---
// ctype.charprops: Utilities to validate properties of groups of characters
//
// These utilities simply factor in the common code in ctype macro vs function
// tests, and in a way implement the ctype specification in a naive way in
// order to compare results.
//---

#ifndef _CTYPE_CHARPROPS_H
#define _CTYPE_CHARPROPS_H

#include <gint/defs/types.h>

#define CP_CNTRL   0x0001
#define CP_PRINT   0x0002
#define CP_SPACE   0x0004
#define CP_BLANK   0x0008
#define CP_GRAPH   0x0010
#define CP_PUNCT   0x0020
#define CP_ALNUM   0x0040
#define CP_ALPHA   0x0080
#define CP_UPPER   0x0100
#define CP_LOWER   0x0200
#define CP_DIGIT   0x0400
#define CP_XDIGIT  0x0800

extern uint16_t charprops[128];

#endif /* _CTYPE_CHARPROPS_H */
